Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jca.cci.connection
Class CciLocalTransactionManager

    java.lang.Object
      org.springframework.transaction.support.AbstractPlatformTransactionManager
          org.springframework.jca.cci.connection.CciLocalTransactionManager

All Implemented Interfaces:
  Serializable, InitializingBean, PlatformTransactionManager, ResourceTransactionManager

    public class CciLocalTransactionManager

extends AbstractPlatformTransactionManager
implements ResourceTransactionManager, InitializingBean

`PlatformTransactionManager` implementation that manages local transactions for a single CCI ConnectionFactory. Binds a CCI Connection from the specified ConnectionFactory to the thread, potentially allowing for one thread-bound Connection per ConnectionFactory.

Application code is required to retrieve the CCI Connection via `ConnectionFactoryUtils.getConnection(ConnectionFactory)` instead of a standard J2EE-style `ConnectionFactory.getConnection()` call. Spring classes such as `CciTemplate` use this strategy implicitly. If not used in combination with this transaction manager, the `ConnectionFactoryUtils` lookup strategy behaves exactly like the native DataSource lookup; it can thus be used in a portable fashion.

Alternatively, you can allow application code to work with the standard J2EE lookup pattern `ConnectionFactory.getConnection()`, for example for legacy code that is not aware of Spring at all. In that case, define a `TransactionAwareConnectionFactoryProxy` for your target ConnectionFactory, which will automatically participate in Spring-managed transactions.

Since:
  1.2
Author:
  Thierry Templier, Juergen Hoeller
See Also:
  `ConnectionFactoryUtils.getConnection(javax.resource.cci.ConnectionFactory)`, `ConnectionFactoryUtils.releaseConnection(javax.resource.cci.Connection, javax.resource.cci.ConnectionFactory)`, `TransactionAwareConnectionFactoryProxy`, `CciTemplate`, Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager
`AbstractPlatformTransactionManager.SuspendedResourcesHolder`

Field Summary

Fields inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager
`logger, SYNCHRONIZATION_ALWAYS, SYNCHRONIZATION_NEVER, SYNCHRONIZATION_ON_ACTUAL_TRANSACTION`

Constructor Summary
`CciLocalTransactionManager()` Create a new CciLocalTransactionManager instance.
`CciLocalTransactionManager(ConnectionFactory connectionFactory)` Create a new CciLocalTransactionManager instance.

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`protected void` | `doBegin(Object transaction, TransactionDefinition definition)` Begin a new transaction with semantics according to the given transaction definition.
`protected void` | `doCleanupAfterCompletion(Object transaction)` Cleanup resources after transaction completion.
`protected void` | `doCommit(DefaultTransactionStatus status)` Perform an actual commit of the given transaction.
`protected Object` | `doGetTransaction()` Return a transaction object for the current transaction state.
`protected void` | `doResume(Object transaction, Object suspendedResources)` Resume the resources of the current transaction.
`protected void` | `doRollback(DefaultTransactionStatus status)` Perform an actual rollback of the given transaction.
`protected void` | `doSetRollbackOnly(DefaultTransactionStatus status)` Set the given transaction rollback-only.
`protected Object` | `doSuspend(Object transaction)` Suspend the resources of the current transaction.
`ConnectionFactory` | `getConnectionFactory()` Return the CCI ConnectionFactory that this instance manages local transactions for.
`Object` | `getResourceFactory()` Return the resource factory that this transaction manager operates on, e.g.
`protected boolean` | `isExistingTransaction(Object transaction)` Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).
`protected boolean` | `isRollbackOnly(Object transaction)`
`void` | `setConnectionFactory(ConnectionFactory cf)` Set the CCI ConnectionFactory that this instance should manage local transactions for.

Methods inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager
`commit, determineTimeout, getDefaultTimeout, getTransaction, getTransactionSynchronization, invokeAfterCompletion, isFailEarlyOnGlobalRollbackOnly, isGlobalRollbackOnParticipationFailure, isNestedTransactionAllowed, isRollbackOnCommitFailure, isValidateExistingTransaction, newTransactionStatus, prepareForCommit, prepareSynchronization, prepareTransactionStatus, registerAfterCompletionWithExistingTransaction, resume, rollback, setDefaultTimeout, setFailEarlyOnGlobalRollbackOnly, setGlobalRollbackOnParticipationFailure, setNestedTransactionAllowed, setRollbackOnCommitFailure, setTransactionSynchronization, setTransactionSynchronizationName, setValidateExistingTransaction, shouldCommitOnGlobalRollbackOnly, suspend, triggerBeforeCommit, triggerBeforeCompletion, useSavepointForNestedTransaction`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.springframework.transaction.PlatformTransactionManager
`commit, getTransaction, rollback`

Constructor Detail

### CciLocalTransactionManager

    public CciLocalTransactionManager()

  Create a new CciLocalTransactionManager instance. A ConnectionFactory has to be set to be able to use it.

  See Also:
    `setConnectionFactory(javax.resource.cci.ConnectionFactory)`

### CciLocalTransactionManager

    public CciLocalTransactionManager(ConnectionFactory connectionFactory)

  Create a new CciLocalTransactionManager instance.

  Parameters:
    `connectionFactory` - CCI ConnectionFactory to manage local transactions for

Method Detail

### setConnectionFactory

    public void setConnectionFactory(ConnectionFactory cf)

  Set the CCI ConnectionFactory that this instance should manage local transactions for.

### getConnectionFactory

    public ConnectionFactory getConnectionFactory()

  Return the CCI ConnectionFactory that this instance manages local transactions for.

### afterPropertiesSet

    public void afterPropertiesSet()

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`

### getResourceFactory

    public Object getResourceFactory()

  Description copied from interface: `ResourceTransactionManager`
  Return the resource factory that this transaction manager operates on, e.g. a JDBC DataSource or a JMS ConnectionFactory.

  This target resource factory is usually used as resource key for `TransactionSynchronizationManager`'s resource bindings per thread.

  Specified by:
    `getResourceFactory` in interface `ResourceTransactionManager`
  Returns:
    the target resource factory (never `null`)
  See Also:
    `TransactionSynchronizationManager.bindResource(java.lang.Object, java.lang.Object)`, `TransactionSynchronizationManager.getResource(java.lang.Object)`

### doGetTransaction

    protected Object doGetTransaction()

  Description copied from class: `AbstractPlatformTransactionManager`
  Return a transaction object for the current transaction state.

  The returned object will usually be specific to the concrete transaction manager implementation, carrying corresponding transaction state in a modifiable fashion. This object will be passed into the other template methods (e.g. doBegin and doCommit), either directly or as part of a DefaultTransactionStatus instance.

  The returned object should contain information about any existing transaction, that is, a transaction that has already started before the current `getTransaction` call on the transaction manager. Consequently, a `doGetTransaction` implementation will usually look for an existing transaction and store corresponding state in the returned transaction object.

  Specified by:
    `doGetTransaction` in class `AbstractPlatformTransactionManager`
  Returns:
    the current transaction object
  See Also:
    `AbstractPlatformTransactionManager.doBegin(java.lang.Object, org.springframework.transaction.TransactionDefinition)`, `AbstractPlatformTransactionManager.doCommit(org.springframework.transaction.support.DefaultTransactionStatus)`, `AbstractPlatformTransactionManager.doRollback(org.springframework.transaction.support.DefaultTransactionStatus)`, `DefaultTransactionStatus.getTransaction()`

### isExistingTransaction

    protected boolean isExistingTransaction(Object transaction)

  Description copied from class: `AbstractPlatformTransactionManager`
  Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).

  The result will be evaluated according to the specified propagation behavior for the new transaction. An existing transaction might get suspended (in case of PROPAGATION_REQUIRES_NEW), or the new transaction might participate in the existing one (in case of PROPAGATION_REQUIRED).

  The default implementation returns `false`, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

  Overrides:
    `isExistingTransaction` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by doGetTransaction
  Returns:
    if there is an existing transaction
  See Also:
    `AbstractPlatformTransactionManager.doGetTransaction()`

### doBegin

    protected void doBegin(Object transaction,
                           TransactionDefinition definition)

  Description copied from class: `AbstractPlatformTransactionManager`
  Begin a new transaction with semantics according to the given transaction definition. Does not have to care about applying the propagation behavior, as this has already been handled by this abstract manager.

  This method gets called when the transaction manager has decided to actually start a new transaction. Either there wasn't any transaction before, or the previous transaction has been suspended.

  A special scenario is a nested transaction without savepoint: If `useSavepointForNestedTransaction()` returns "false", this method will be called to start a nested transaction when necessary. In such a context, there will be an active transaction: The implementation of this method has to detect this and start an appropriate nested transaction.

  Specified by:
    `doBegin` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`
    `definition` - TransactionDefinition instance, describing propagation behavior, isolation level, read-only flag, timeout, and transaction name

### doSuspend

    protected Object doSuspend(Object transaction)

  Description copied from class: `AbstractPlatformTransactionManager`
  Suspend the resources of the current transaction. Transaction synchronization will already have been suspended.

  The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

  Overrides:
    `doSuspend` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`
  Returns:
    an object that holds suspended resources (will be kept unexamined for passing it into doResume)
  See Also:
    `AbstractPlatformTransactionManager.doResume(java.lang.Object, java.lang.Object)`

### doResume

    protected void doResume(Object transaction,
                            Object suspendedResources)

  Description copied from class: `AbstractPlatformTransactionManager`
  Resume the resources of the current transaction. Transaction synchronization will be resumed afterwards.

  The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

  Overrides:
    `doResume` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`
    `suspendedResources` - the object that holds suspended resources, as returned by doSuspend
  See Also:
    `AbstractPlatformTransactionManager.doSuspend(java.lang.Object)`

### isRollbackOnly

    protected boolean isRollbackOnly(Object transaction)
                              throws TransactionException

  Throws:
    `TransactionException`

### doCommit

    protected void doCommit(DefaultTransactionStatus status)

  Description copied from class: `AbstractPlatformTransactionManager`
  Perform an actual commit of the given transaction.

  An implementation does not need to check the "new transaction" flag or the rollback-only flag; this will already have been handled before. Usually, a straight commit will be performed on the transaction object contained in the passed-in status.

  Specified by:
    `doCommit` in class `AbstractPlatformTransactionManager`
  Parameters:
    `status` - the status representation of the transaction
  See Also:
    `DefaultTransactionStatus.getTransaction()`

### doRollback

    protected void doRollback(DefaultTransactionStatus status)

  Description copied from class: `AbstractPlatformTransactionManager`
  Perform an actual rollback of the given transaction.

  An implementation does not need to check the "new transaction" flag; this will already have been handled before. Usually, a straight rollback will be performed on the transaction object contained in the passed-in status.

  Specified by:
    `doRollback` in class `AbstractPlatformTransactionManager`
  Parameters:
    `status` - the status representation of the transaction
  See Also:
    `DefaultTransactionStatus.getTransaction()`

### doSetRollbackOnly

    protected void doSetRollbackOnly(DefaultTransactionStatus status)

  Description copied from class: `AbstractPlatformTransactionManager`
  Set the given transaction rollback-only. Only called on rollback if the current transaction participates in an existing one.

  The default implementation throws an IllegalTransactionStateException, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

  Overrides:
    `doSetRollbackOnly` in class `AbstractPlatformTransactionManager`
  Parameters:
    `status` - the status representation of the transaction

### doCleanupAfterCompletion

    protected void doCleanupAfterCompletion(Object transaction)

  Description copied from class: `AbstractPlatformTransactionManager`
  Cleanup resources after transaction completion.

  Called after `doCommit` and `doRollback` execution, on any outcome. The default implementation does nothing.

  Should not throw any exceptions but just issue warnings on errors.

  Overrides:
    `doCleanupAfterCompletion` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD